Loading...
Searching...
No Matches
Finite Impulse Response (FIR) Sparse Filters
Signal Processing Functions | Signal Processing Functions » Finite Impulse Response (FIR) Decimator

## Functions

void | ne10_fir_sparse_float_c (ne10_fir_sparse_instance_f32_t *S, ne10_float32_t *pSrc, ne10_float32_t *pDst, ne10_float32_t *pScratchIn, ne10_uint32_t blockSize)
| Processing function for the floating-point sparse FIR filter.

## Detailed Description

  This group of functions implements sparse FIR filters. Sparse FIR filters are equivalent to standard FIR filters except that most of the coefficients are equal to zero. Sparse filters are used for simulating reflections in communications and audio applications.

There are separate functions for floating-point data types. The functions operate on blocks of input and output data and each call to the function processes `blockSize` samples through the filter. `pSrc` and `pDst` points to input and output arrays respectively containing `blockSize` values.

Algorithm:
  The sparse filter instant structure contains an array of tap indices `pTapDelay` which specifies the locations of the non-zero coefficients. This is in addition to the coefficient array `b`. The implementation essentially skips the multiplications by zero and leads to an efficient realization.

            y[n] = b[0] * x[n-pTapDelay[0]] + b[1] * x[n-pTapDelay[1]] + b[2] * x[n-pTapDelay[2]] + ...+ b[numTaps-1] * x[n-pTapDelay[numTaps-1]]

  Sparse FIR filter. b[n] represents the filter coefficients

  `pCoeffs` points to a coefficient array of size `numTaps`; `pTapDelay` points to an array of nonzero indices and is also of size `numTaps`; `pState` points to a state array of size `maxDelay + blockSize`, where `maxDelay` is the largest offset value that is ever used in the `pTapDelay` array. Some of the processing functions also require temporary working buffers.

Instance Structure
  The coefficients and state variables for a filter are stored together in an instance data structure. A separate instance structure must be defined for each filter. Coefficient and offset arrays may be shared among several instances while state variable arrays cannot be shared. There are separate instance structure declarations for each of the 4 supported data types.

Initialization Functions
  There is also an associated initialization function for each data type. The initialization function performs the following operations:
  - Sets the values of the internal structure fields.
  - Zeros out the values in the state buffer.

  Use of the initialization function is optional. However, if the initialization function is used, then the instance structure cannot be placed into a const data section. To place an instance structure into a const data section, the instance structure must be manually initialized. Set the values in the state buffer to zeros before static initialization. The code below statically initializes each of the 4 different data type filter instance structures

      *ne10_fir_sparse_instance_f32_t S = {numTaps, 0, pState, pCoeffs, maxDelay, pTapDelay};

## Function Documentation

## ne10_fir_sparse_float_c()

void ne10_fir_sparse_float_c | ( | ne10_fir_sparse_instance_f32_t * | S,
|  | ne10_float32_t * | pSrc,
|  | ne10_float32_t * | pDst,
|  | ne10_float32_t * | pScratchIn,
|  | ne10_uint32_t | blockSize
| ) |  |

Processing function for the floating-point sparse FIR filter.

Parameters

  [in] | *S | points to an instance of the floating-point sparse FIR structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block of output data
  [in] | *pScratchIn | points to a temporary buffer of size blockSize.
  [in] | blockSize | number of input samples to process per call.

Returns
  none.

Definition at line 1439 of file NE10_fir.c.